"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParsableBurn = exports.ParsableBurnRole = exports.ParsableVesting = exports.ParsableLocker = exports.ParsableProperty = exports.ParsablePlatform = void 0;
const anchor_1 = require("@project-serum/anchor");
const types_1 = require("../types");
/**
 * Class decorator to define an interface with static methods
 * Reference: https://github.com/Microsoft/TypeScript/issues/13462#issuecomment-295685298
 */
function staticImplements() {
    return (constructor) => {
        constructor;
    };
}
function parseAnchorAccount(accountName, data) {
    const discriminator = anchor_1.BorshAccountsCoder.accountDiscriminator(accountName);
    if (discriminator.compare(data.slice(0, 8))) {
        console.error("incorrect account name during parsing");
        return null;
    }
    try {
        return types_1.accountsCoder.decode(accountName, data);
    }
    catch (_e) {
        console.error("unknown account name during parsing");
        return null;
    }
}
// YOUR ACCOUNTS
let ParsablePlatform = class ParsablePlatform {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Platform, data);
        }
        catch (e) {
            console.error(`error while parsing Platform: ${e}`);
            return null;
        }
    }
};
ParsablePlatform = __decorate([
    staticImplements()
], ParsablePlatform);
exports.ParsablePlatform = ParsablePlatform;
let ParsableProperty = class ParsableProperty {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Property, data);
        }
        catch (e) {
            console.error(`error while parsing Property: ${e}`);
            return null;
        }
    }
};
ParsableProperty = __decorate([
    staticImplements()
], ParsableProperty);
exports.ParsableProperty = ParsableProperty;
let ParsableLocker = class ParsableLocker {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Locker, data);
        }
        catch (e) {
            console.error(`error while parsing PrivateSaleLocker: ${e}`);
            return null;
        }
    }
};
ParsableLocker = __decorate([
    staticImplements()
], ParsableLocker);
exports.ParsableLocker = ParsableLocker;
let ParsableVesting = class ParsableVesting {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Vesting, data);
        }
        catch (e) {
            console.error(`error while parsing PublicSaleVesting: ${e}`);
            return null;
        }
    }
};
ParsableVesting = __decorate([
    staticImplements()
], ParsableVesting);
exports.ParsableVesting = ParsableVesting;
let ParsableBurnRole = class ParsableBurnRole {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.BurnRole, data);
        }
        catch (e) {
            console.error(`error while parsing BurnRole: ${e}`);
            return null;
        }
    }
};
ParsableBurnRole = __decorate([
    staticImplements()
], ParsableBurnRole);
exports.ParsableBurnRole = ParsableBurnRole;
let ParsableBurn = class ParsableBurn {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Burn, data);
        }
        catch (e) {
            console.error(`error while parsing Burn: ${e}`);
            return null;
        }
    }
};
ParsableBurn = __decorate([
    staticImplements()
], ParsableBurn);
exports.ParsableBurn = ParsableBurn;
