"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProperty = void 0;
const web3_js_1 = require("@solana/web3.js");
const spl_token_1 = require("@solana/spl-token");
const token_1 = require("@project-serum/anchor/dist/cjs/utils/token");
function createProperty(program, params) {
    return __awaiter(this, void 0, void 0, function* () {
        const { accounts, inputs } = params;
        const ix = yield program.methods
            .createProperty(inputs.privateSaleStartTime, inputs.privateSaleEndTime, inputs.privateSaleSupplyAmount, inputs.privateSaleTokenPrice, inputs.privateSaleMinimumPurchaseAmount, inputs.privateSaleCommissionAmount, inputs.privateSaleReferralCommissionAmount, inputs.privateSaleDiscountPercentage, inputs.privateSaleTgePercentage, inputs.privateSaleUnlockPeriod, inputs.privateSaleUnlockDuration, inputs.privateSaleMinimumPlatformAmount, inputs.publicSaleStartTime, inputs.publicSaleEndTime, inputs.publicSaleSupplyAmount, inputs.publicSaleTokenPrice, inputs.publicSaleMinimumPurchaseAmount, inputs.publicSaleCommissionAmount, inputs.publicSaleCommissionBoostAmount, inputs.publicSaleReferralCommissionAmount, inputs.publicSaleReferralCommissionBoostAmount, inputs.publicSaleReferralCommissionBoostThreshold, inputs.bump)
            .accounts(Object.assign(Object.assign({}, accounts), { tokenProgram: spl_token_1.TOKEN_PROGRAM_ID, associatedTokenProgram: token_1.ASSOCIATED_PROGRAM_ID, systemProgram: web3_js_1.SystemProgram.programId, rent: web3_js_1.SYSVAR_RENT_PUBKEY }))
            .instruction();
        return {
            instructions: [ix],
            cleanupInstructions: [],
            signers: [],
        };
    });
}
exports.createProperty = createProperty;
