"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateProperty = void 0;
function updateProperty(program, params) {
    return __awaiter(this, void 0, void 0, function* () {
        const { accounts, inputs } = params;
        const ix = yield program.methods
            .updateProperty(inputs.privateSaleStartTime, inputs.privateSaleEndTime, inputs.privateSaleSupplyAmount, inputs.privateSaleTokenPrice, inputs.privateSaleMinimumPurchaseAmount, inputs.privateSaleCommissionAmount, inputs.privateSaleReferralCommissionAmount, inputs.privateSaleDiscountPercentage, inputs.privateSaleTgePercentage, inputs.privateSaleUnlockPeriod, inputs.privateSaleUnlockDuration, inputs.privateSaleMinimumPlatformAmount, inputs.publicSaleStartTime, inputs.publicSaleEndTime, inputs.publicSaleSupplyAmount, inputs.publicSaleTokenPrice, inputs.publicSaleMinimumPurchaseAmount, inputs.publicSaleCommissionAmount, inputs.publicSaleCommissionBoostAmount, inputs.publicSaleReferralCommissionAmount, inputs.publicSaleReferralCommissionBoostAmount, inputs.publicSaleReferralCommissionBoostThreshold)
            .accounts(Object.assign({}, accounts))
            .instruction();
        return {
            instructions: [ix],
            cleanupInstructions: [],
            signers: [],
        };
    });
}
exports.updateProperty = updateProperty;
